package com.example.springdemo.controller;

import com.example.springdemo.entities.Merchants;
import com.example.springdemo.entities.password.MerchantsPassword;
import com.example.springdemo.service.MerchantsService;
import jakarta.annotation.Resource;
import lombok.Data;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

@RestController
@RequestMapping("/merchants")
public class MerchantsController {
    @Resource
    private MerchantsService merchantsService;

    @PostMapping("/add")
    public Merchants addMerchants(@RequestBody wrapperMerchantAndPassword wrapperMerchantAndPassword) {
        return merchantsService.addMerchant(
                wrapperMerchantAndPassword.merchant,
                wrapperMerchantAndPassword.merchantPassword);
    }

    @Data
    public static class wrapperMerchantAndPassword {
        public Merchants merchant;
        public MerchantsPassword merchantPassword;
    }

    @DeleteMapping("/delete/id")
    public void deleteMerchants(@RequestParam("id") Long merchantId) {
        merchantsService.deleteMerchantById(merchantId);
    }

    @PutMapping("/update/info")
    public Merchants updateMerchants(@RequestBody Merchants merchant) {
        return merchantsService.updateMerchant(merchant);
    }

    @GetMapping("/find/all")
    public Iterable<Merchants> getMerchants() {
        return merchantsService.findAllMerchants();
    }

    @GetMapping("/find/name")
    public Optional<Merchants> getMerchantsByName(@RequestParam("name") String name) {
        return merchantsService.findByName(name);
    }

    @GetMapping("/find/id")
    public Optional<Merchants> getMerchantsById(@RequestParam("id") Long merchantId) {
        return merchantsService.findById(merchantId);
    }

    @PutMapping("/update/password")
    public int updatePassword(@RequestParam("password") String password, @RequestParam("merchantId") Long merchantId) {
        return merchantsService.updateMerchantPasswordById(password, merchantId);
    }
}
