package com.example.springdemo.controller;

import com.example.springdemo.entities.RBAC.Permissions;
import com.example.springdemo.service.PermissionsService;
import com.example.springdemo.utils.RoleVerificationAnnotation;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RestController
@RequestMapping("/permissions")
@RoleVerificationAnnotation(UserIDList = {1})
public class PermissionsController {
    @Resource
    private PermissionsService permissionsService;

    @PostMapping("/add")
    public Permissions addPermissions(@RequestBody Permissions permission) {
        return permissionsService.addPermission(permission);
    }

    @DeleteMapping("/delete/id")
    public void deletePermissions(@RequestParam("id") Long permissionId) {
        permissionsService.deletePermissionById(permissionId);
    }

    @PutMapping("/update")
    public Permissions updatePermissions(@RequestBody Permissions permission) {
        return permissionsService.updatePermission(permission);
    }

    @GetMapping("/find/all")
    public List<Permissions> getPermissions() {
        return permissionsService.findAllPermissions();
    }

    @GetMapping("/find/id")
    public Optional<Permissions> getPermissionsById(@RequestParam("id") Long permissionsId) {
        return permissionsService.findById(permissionsId);
    }
}
