package com.example.springdemo.controller;

import com.example.springdemo.entities.RBAC.RolesPermissions;
import com.example.springdemo.service.RolesPermissionsService;
import com.example.springdemo.utils.RoleVerificationAnnotation;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RoleVerificationAnnotation(UserIDList = {1})
@RestController
@RequestMapping("/rolesPermissions")
public class RolesPermissionsController {
    @Resource
    private RolesPermissionsService rolesPermissionsService;

    @PostMapping("/assign")
    public RolesPermissions assignPermissionsToRole(@RequestBody RolesPermissions rolesPermissions) {
        return rolesPermissionsService.AssignPermissionsToRole(rolesPermissions);
    }

    @DeleteMapping("/remove")
    public String removePermissionsFromRole(@RequestParam(name = "roleId") Long roleId,
                                            @RequestParam(name = "permissionId") Long permissionId) {
        if (rolesPermissionsService.RemovePermissionsFromRole(roleId, permissionId) != 0) {
            return "remove success";
        } else {
            return "remove failed, you can't update or delete admin role";
        }
    }

    @PutMapping("/update")
    public String updateRolePermissions(@RequestParam(name = "roleId") Long roleId,
                                        @RequestParam(name = "permissionId") Long permissionId) {
        if (rolesPermissionsService.updateRolePermissions(roleId, permissionId) != 0) {
            return "update success";
        } else {
            return "update failed, you can't update or delete admin role";
        }
    }

    @GetMapping("/find/all")
    public List<RolesPermissions> findAllRolesPermissions() {
        return rolesPermissionsService.findAllRolesPermissions();
    }

    @GetMapping("/find/id")
    public Optional<RolesPermissions> getRolePermissionById(@RequestParam(name = "id") Long rolesPermissionsId) {
        return rolesPermissionsService.findById(rolesPermissionsId);
    }

}
