package com.example.springdemo.dao;

import com.example.springdemo.entities.password.UsersPassword;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

@Repository
public interface UsersPasswordRepository
        extends JpaRepository<UsersPassword, Long> {

    //修改密码
    @Query("update UsersPassword UsersPwd set UsersPwd.password = ?1 where UsersPwd.users.id = ?2")
    int updatePassword(String password, Long userID);

    //删除账户时删除密码
    void deleteByUsersId(Long userID);

    //根据用户ID查找密码
    UsersPassword findByUsersId(Long userID);

    //根据用户名查找密码
    UsersPassword findByUsersName(String userName);
}
