package com.example.springdemo.entities;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "Merchants")
public class Merchants {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;//主键,商家编号
    private String name;//店铺名字
    private String address;//店铺地址
    @Column(name = "phoneNumber")
    private String phoneNumber;//商家联系方式
    private String description;//店铺描述

    //商家和菜品是一对多的关系，有mappedBy的时候，表示Merchants的dishes 字段放弃维护权，而将维护权交给了Dishes的关联属性merchants
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @JoinTable(name = "merchants_dishes",
            joinColumns = @JoinColumn(name = "merchantsId"),
            inverseJoinColumns = @JoinColumn(name = "dishesId"))
    private List<Dishes> dishes;//菜品
}
