package com.example.springdemo.entities;

import jakarta.persistence.*;
import lombok.*;

//订单中的菜品
@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "OrderDishes")
public class OrderDishes {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;//主键ID

    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @PrimaryKeyJoinColumn(name = "dishesId", referencedColumnName = "id")
    private Dishes dishes;//菜品ID

    @OneToOne(cascade = CascadeType.ALL)
    @PrimaryKeyJoinColumn(name = "merchantsId", referencedColumnName = "id")
    private Merchants merchants;//商家ID

    @ManyToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinTable(name = "orders_orderDishes",
            joinColumns = @JoinColumn(name = "orderDishesId"),
            inverseJoinColumns = @JoinColumn(name = "ordersId"))
    private Orders orders;//订单ID
}