package com.example.springdemo.security.events;

import com.example.springdemo.security.utils.JwtTokenProvider;
import com.example.springdemo.utils.verificationAnnotation.Result;
import jakarta.annotation.Resource;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.jetbrains.annotations.NotNull;
import org.springframework.security.core.Authentication;
import org.springframework.stereotype.Component;

import java.io.IOException;

@Slf4j
@Component
public class AuthSuccess {
    @Resource
    private JwtTokenProvider JwtTokenProvider;

    public void onAuthSuccess(HttpServletRequest request,
                              @NotNull HttpServletResponse response,
                              @NotNull Authentication authentication) throws IOException, ServletException {
        Result<Object> result = Result.of(200, "Login success");

        log.info("User {} login success", authentication.getName());

        String token = JwtTokenProvider.generateToken(authentication);

        result.setData(token);

        String responseJson = result.toString();

        response.setCharacterEncoding("UTF-8");
        response.setContentType("application/json; charset=utf-8");
        response.getWriter().println(responseJson);
        response.getWriter().flush();

    }
}
