package com.example.springdemo.serviceImpl;

import com.example.springdemo.dao.RolesPermissionsRepository;
import com.example.springdemo.entities.RBAC.RolesPermissions;
import com.example.springdemo.service.RolesPermissionsService;
import jakarta.annotation.Resource;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Optional;

@Service
public class RolesPermissionsServiceImpl implements RolesPermissionsService {
    @Resource
    private RolesPermissionsRepository rolesPermissionsRepository;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public RolesPermissions AssignPermissionsToRole(RolesPermissions rolesPermissions) {
        return rolesPermissionsRepository.save(rolesPermissions);
    }

    @Override
    @Modifying
    @Transactional(rollbackFor = Exception.class)
    public int RemovePermissionsFromRole(Long roleId, Long permissionId) {
        int count;
        if (this.CheckIfDeleteOrUpdateAdmin(roleId)) {
            count = rolesPermissionsRepository.RemovePermissionsFromRole(roleId, permissionId);
        } else {
            count = 0;
        }
        return count;
    }

    @Override
    @Modifying
    @Transactional(rollbackFor = Exception.class)
    public int updateRolePermissions(Long roleId, Long permissionId) {
        int count;
        if (this.CheckIfDeleteOrUpdateAdmin(roleId)) {
            count = rolesPermissionsRepository.updateRolePermissions(roleId, permissionId);
        } else {
            count = 0;
        }
        return count;
    }

    @Override
    public Optional<RolesPermissions> findById(Long rolesPermissionsId) {
        return rolesPermissionsRepository.findById(rolesPermissionsId);
    }

    //TODO: 查找全部时返回名字而不是id
    @Override
    public List<RolesPermissions> findAllRolesPermissions() {
        return rolesPermissionsRepository.findAll();
    }

    @Override
    //检查是否删除或更新管理员
    public Boolean CheckIfDeleteOrUpdateAdmin(Long roleId) {
        return roleId != 1;
    }
}
